/*============================================================*/
/*============================================================*/
/*==														==*/
/*==				InitGameStructs	Header					==*/
/*==														==*/
/*============================================================*/
/*============================================================*/


/*========================================================  Defines  */

#define	kSmInitBallXPos			384		/* ball constants */
#define	kSmInitBallZPos			14000
#define	kSmInitBallXVel			-4800
#define	kSmInitBallZVel			0
#define	kLgInitBallXPos			384
#define	kLgInitBallZPos			17728
#define	kLgInitBallXVel			-5600	/* was -5600 */
#define	kLgInitBallZVel			0


/*========================================================  Routines  */

void SetPrefsToDefault (void);
void LoadThePreferences (void);
void LoadLargeDataStructures (void);
void VarInit (void);
void InitBallData (void);
void InitPlayerData (void);
void InitOpponentData (void);
void InitDigiDispData (void);


/*========================================================  External Variables  */

extern ballType			theBall;
extern playerType		thePlayer;
extern playerType		theOpponent;
extern doorType			theDoor;
extern digiDispType		scoreDisplays[2];
extern cursorType		boardCursor;
extern replayType		*replayData;
extern statType			theStats[10];
extern string31			theNames[10];
extern string31			mostTitlesName, mostPointsName;
extern string31			mostFoulsName, mostCritsName;
extern macEnvironment	thisMac;
extern RGBColor			starColors[3];
extern Rect				screenRect, nullRect, replayRect, colonDest, mouseFrame;
extern Rect				leftArrowSrc, rightArrowSrc, leftArrowDest, rightArrowDest;
extern Rect				leftArrowStorage, rightArrowStorage;
extern Rect				timingSource, leftTimingDest, rightTimingDest;
extern Rect				playerSrcRects[9][3], fadeMaskRects[9][3], opponentSrcRects[9][3];
extern Rect				colonSrc[2];
extern Point			starList[kNumberOfStars];
extern RgnHandle		screenRgn;									/* pull later */
extern long				mostTitlesDate, mostPointsDate, lifeTime;
extern long				mostFoulsDate, mostCritsDate, speedFlag;
extern long				thisTime, encryptedNumber;
extern short			mostTitles, mostPoints, mostFouls, mostCrits;
extern short			screenWide, screenHigh, displayHCenter, displayVCenter, isDepth;
extern short			displayMode, arenaSize, primaryMode, whichGame, isLeague;
extern short			whichHumanNumber, leftPlayerNumber, rightPlayerNumber;
extern short			screenHCenter, screenVCenter, soundVolume;
extern short			maxBoardForce;
extern short			antiWhosBall[4];
extern short			vertTable[41][81];
extern short			fadeMaskSequence[69];
extern short			antiFacing[9];
extern short			spacialToDirection[9];
extern short			boardForceTable[9][2];
extern short			teaksThreshholds[10];
extern short			*littleForceTable, *juniorForceTable, *varsityForceTable;
extern short			*minorForceTable, *proForceTable;
extern Boolean			quitting, leftGoalIsPlayers, enableBackground;
extern Boolean			useQD, isColor, showBoardCursor, autoSetDepth, enableAnnouncer;
extern Boolean			pausing, newGame, autoTeamsDialog, canReplay, doSkipFrames;
extern Boolean			replayGoals, replayFouls, replayOnR, replaySomething, willUseQD;
extern Boolean			soundOn, beamSoundOn, incidentSoundOn, collisionSoundOn;
extern Boolean			crowdSoundOn, smsActivated, doZooms, replayZooms, netOnly;
